﻿// 0030.ThreadTest_001.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//

#include "pch.h"
#include "framework.h"
#include "0030.ThreadTest_001.h"
#include "ThreadSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// 唯一のアプリケーション オブジェクトです
CWinApp theApp;
using namespace std;

bool g_flag = false;    /* グローバルなフラグ */
LONG g_intcnt = 0;      /* グローバルな割り込み回数カウンタ */

#define MAX_THREADS 2   /* 実行スレッド数 */
#define MAX_LOOP 10000*10000        /* 試行ループ回数 */

int main()
{
    int nRetCode = 0;

    HMODULE hModule = ::GetModuleHandle(nullptr);

    if (hModule != nullptr)
    {
        // MFC を初期化して、エラーの場合は結果を出力する
        if (!AfxWinInit(hModule, nullptr, ::GetCommandLine(), 0))
        {
            // TODO: アプリケーションの動作を記述するコードをここに挿入してください。
            wprintf(L"致命的なエラー: MFC の初期化が失敗しました\n");
            nRetCode = 1;
        }
        else
        {
            main2();
        }
    }
    else
    {
        // TODO: 必要に応じてエラー コードを変更してください
        wprintf(L"致命的なエラー: GetModuleHandle が失敗しました\n");
        nRetCode = 1;
    }

    return nRetCode;
}


/*****************************************************
* main2
*****************************************************/
int main2() {
    HANDLE hThreads[MAX_THREADS] = {}; /* ゼロクリア */

    /* n個のスレッドを生成する */
    for (int tc = 0; tc < MAX_THREADS; tc++) {
        CWinThread* m_pThread = AfxBeginThread(WorkerThread, 0);

        if (m_pThread == NULL) {
            /* エラー */
            ::printf("AfxBeginThread : Error\n");
            break;
        }
        else {
            ::printf("AfxBeginThread : WorkerThread 生成成功 [%08X]\n", m_pThread->m_nThreadID);
            hThreads[tc] = m_pThread->m_hThread;
        }
    }

    /* スレッド終了 待ち合わせ */
    WaitForMultipleObjects(MAX_THREADS, hThreads, true, INFINITE);

    /* 割り込み率を表示 */
    ::printf("スレッド数=%d\n", MAX_THREADS);
    ::printf("試行ループ回数=%d\n", MAX_THREADS * MAX_LOOP);
    ::printf("割り込まれた回数=%d\n", g_intcnt);
    ::printf("割り込まれた率=%4.4f%%\n", ((g_intcnt * 1.0) / (MAX_THREADS * MAX_LOOP)) * 100);

    ::printf("main2 Done.\n");
    return(0);
}

/*****************************************************
* worker thread
*****************************************************/
UINT WorkerThread(LPVOID arg)
{
    DWORD thread_id = GetCurrentThreadId();
    ::printf("＞＞[%08X] スレッド開始\n", thread_id);

    unsigned int cnt = 0;
    bool l_flag = false;

    while (cnt++ < MAX_LOOP) {
        
        if (g_flag == false) {  /* (1) 某処理Aが実行できるか確認 */

            /* 別スレッドを排他するつもり */
            g_flag = true;      /* (2) 排他開始 */

            if (g_flag == false) {  /* (3) */
                /* (2)と(3)の間に、別スレッドが割り込んで g_flag = false に更新した！ */
                ::printf("[%08X] 割り込み発生：cnt=%u\n", thread_id, cnt);

                /* 割り込まれた回数をカウントする */
                InterlockedIncrement(&g_intcnt);
            }
            else {
                /* ok */
            }

            /* (*4) 某処理A */
            /* 例えば・・・ */
            double a = 100*3.14;

            /* (*5) 排他解除 */
            g_flag = false;
        }
        else {
            /* do nothing */
        }
    }
    ::printf("＜＜[%08X] スレッド終了\n", thread_id);
    return 0;
}

